﻿using System.Collections.Generic;
using Microsoft.AnalysisServices.Tabular;
using Microsoft.AnalysisServices.Tabular.DataRefresh;
namespace ListTables {
    class Program {

        static void Main(string[] args) {
            string serverName = @"gap\tabular";
            string databaseName = "Contoso";

            Server server = new Server();
            server.Connect(serverName);
            Database db = server.Databases[databaseName];
            Table tableSales = db.Model.Tables["Sales"];
            Partition partition = tableSales.Partitions[0];

            OverrideCollection oc = new OverrideCollection {
                Partitions = {
                    new PartitionOverride {
                        OriginalObject = partition,
                        Source = new QueryPartitionSourceOverride {
                            DataSource = ((QueryPartitionSource)partition.Source).DataSource,
                            Query = "SELECT * FROM [Analytics].[Sales] WHERE [Order Date] >= '20170211'"
                        }
                    }
                }
            };
            var listOc = new List<OverrideCollection>();
            listOc.Add(oc);
            partition.RequestRefresh(RefreshType.Add, listOc);
            db.Model.SaveChanges();
        }
    }
}